package io.github.null2264.tsukumogami.core.commands.converters.impl

import io.github.null2264.tsukumogami.core.Context
import io.github.null2264.tsukumogami.core.commands.converters.Converter

class StringConverter : Converter<String>() {

    override var parsed: String = ""

    override suspend fun consume(context: Context, inputs: MutableList<String>): Boolean {
        this.parsed = if (isGreedy && inputs.size > 1) run {
            val limit = inputs.size
            var buffer = ""
            var count = 0
            for (i in (1..limit)) {
                if (++count > 1) buffer += " "
                if (count <= limit) {
                    buffer += inputs.removeFirstOrNull() ?: ""
                } else break
            }
            buffer
        } else inputs.removeFirstOrNull().orEmpty()
        return this.parsed.isNotEmpty()
    }
}
