package io.github.null2264.tsukumogami.core.commands.converters.impl

import io.github.null2264.tsukumogami.core.Context
import io.github.null2264.tsukumogami.core.commands.converters.Converter
import io.github.null2264.tsukumogami.core.exceptions.CommandException
import java.net.URI

class URIConverter : Converter<URI>() {

    override var isGreedy: Boolean
        get() = false
        set(_) { error("HttpConverter can't be greedy") }

    override lateinit var parsed: URI

    override suspend fun consume(context: Context, inputs: MutableList<String>): Boolean {
        val input = inputs.getOrNull(0) ?: return false
        this.parsed = try {
            URI(input)
        } catch (e: Exception) {
            throw CommandException("Failed to parse URI", e)
        }
        return true
    }
}
